uses dos,graph,crt,mouse;
type
point3d = Record
 x,y,z:Real;
 end;
var
tcos,tsin:array[0..359] of Extended;
gd,gm,oz,ox,oy,m,clr,pov,xm,ym,maxx,maxy:Integer;
perspective,lm,mm,rm,auto,usepages:Boolean;
x:Real;
e:Integer;
key:Char;
f:Text;
pt1,pt2:Point3d;
mapname,wherebgi:String;
function inttostr(x:longInt): String;
var
 d:String;
begin
str(x,d);
inttostr:=d;
end;
function strtoint(s:String): longInt;
var
 v:longInt;
d:Integer;
begin
val(s,v,d);
strtoint:=v;
if d <> 0 then strtoint:=0;
end;
procedure rotate(Ax,Ay,Az:Integer; var p: Point3d);
var
s1,s2,s3,c1,c2,c3:Extended;
Puit:Point3d;
begin
s1:=tsin[trunc(ax)];
c1:=tcos[trunc(ax)];
s2:=tsin[trunc(ay)];
c2:=tcos[trunc(ay)];
s3:=tsin[trunc(az)];
c3:=tcos[trunc(az)];
puit.x:=trunc(p.x*(c2*c3)+p.y*(c2*s3)-p.z*s2);
puit.y:=trunc(p.x*(s1*s2*c3-c1*s3)+p.y*(s1*s2*s3+c1*c3)+p.z*(s1*c2));
puit.z:=trunc(p.x*(c1*s2*c3+s1*s3)+p.y*(c1*s2*s3-s1*c3)+p.z*(c1*c2));
p:=puit;
end;
procedure transform(pt3d:Point3d; var x2d,y2d:Integer);
var
Thit:Real;
begin
if perspective then
begin
Thit:=1 / (1-pt3d.x / e);
x2d:= trunc((maxx div 2) + pt3d.y*thit);
y2d:= trunc((maxy div 2) - pt3d.z*thit);
end
else
begin
x2d:=(maxx div 2) + round(pt3d.y);
y2d:=(maxy div 2) - round(pt3d.z);
end;
end;
procedure linec(x1,y1,x2,y2:Integer; color:byte);
begin
setcolor(color);line(x1,y1,x2,y2);
end;
procedure line3d(point1,point2:Point3d; color:byte);
var
x1,x2,y1,y2:Integer;
begin
transform(point1,x1,y1);
transform(point2,x2,y2);
linec(x1,y1,x2,y2,color);
end;
function getmapname: String;
var
dir,mask,olddir:String;
files:Searchrec;
names:Array[0..100] of string[12];
cnt,cnt2,x,y:Integer;
begin
dir:='maps';
mask:='*.*';
getdir(0,olddir);
chdir(dir);
findfirst(mask,anyfile,files);
cnt:=0;
while doserror = 0 do
begin
if (files.name <> '.') and (files.name <> '..') then
begin
cnt:=cnt+1;
names[cnt]:=files.name;
end;
findnext(files);
end;
chdir(olddir);
clrscr;
writeln('-=-=-=-=-=- -=-=-=-=-=-=-');
x:=1;
y:=1;
for cnt2 := 1 to cnt do
begin
y:=y+1;
if y > 20 then
begin
y:=2;
x:=x+16;
end;
gotoxy(x,y);
write('',cnt2,': ',names[cnt2]);
end;
gotoxy(1,21);
writeln('-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-');
writeln('0: 室');
writeln(cnt+1, '  : 室');
write(' : '); readln(cnt2);
if cnt2 <= 0 then halt;
if cnt2 > cnt then halt;
if dir[length(dir)] <> '\' then getmapname:=dir+'\'+names[cnt2] else getmapname:=dir+names[cnt2];
end;
begin
for int := 0 to 359 do
begin
tsin[int]:=sin(int*gr);
tcos[int]:=cos(int*gr);
end;
mapname:=getmapname;
usepages:=true;
wherebgi:='';
gd:=9;gm:=1;
maxx:=640;
maxy:=350;
initgraph(gd,gm,wherebgi);
resetmouse;
hidemouse;
m:=1;
e:=1500;
perspective:=true;
ox:=0;
oy:=-45;
oz:=0;
auto:=false;
pov:=1;
repeat
key:=#1;
if keypressed then key:=readkey;
if usepages then
begin
m:=1-m;
setactivepage(m);
end;
cleardevice;
setcolor(15);
outtextxy(10,10,'Oz: '+inttostr(oz)+' Oy: '+inttostr(oy)+' Speed:'+inttostr(pov));
if oy > 359 then oy := 0;
if oy < 0 then oy:=359;
if oz > 359 then oz := 0;
if oz < 0 then oz:=359;
assign(f,mapname);
reset(f);
while not eof(f) do
begin
readln(f,pt1.x,pt1.y,pt1.z,pt2.x,pt2.y,pt2.z,clr);
if (clr <= 0) or (clr > 15) then clr:=15;
rotate(ox,oy,oz,pt1);
rotate(ox,oy,oz,pt2);
line3d(pt1,pt2,clr);
key:=#1;
readmousestate(xm,ym,lm,mm,rm);
if (lm) then auto:=false;
if (rm) then auto:=true;
if (xm <> maxx div 2) or (ym <> maxy div 2) then
begin
oy:=oy+(maxy div 2 - ym);
if not auto then oz:=oz+(maxx div 2-xm);
end;
resetmouse;
if keypressed then key:=readkey;
if key=#27 then
begin
closegraph;
mapname:=getmapname;
initgraph(gd,gm,wherebgi);
end;
if key = #0 then
begin
key:=readkey;
if key=#73 then oy:=oy-10;
if key=#81 then oy:=oy+10;
if key=#80 then pov:= pov-1;
if key=#72 then pov:= pov+1;
if pov < 0 then pov:= 0;
end;
end;
close(f);
if usepages then setvisualpage(m);
if auto then oz:=oz+pov;
until key = #27;
closegraph;
end.