unit mouse;
interface
type
 str6 = string[6];
procedure resetmouse;
procedure showmouse;
procedure hidemouse;
procedure readmousestate(var x,y:Integer; var l,m,r:Boolean);
procedure gotomouse(x,y:Integer);
procedure cursorlim(x1,y1,x2,y2:Integer);
procedure setcursorform(x,y:Integer; mask:Pointer);
procedure getcursorformfile(s:String);
function strtoint(s:String): longInt;
function vs(x,tos:LongInt):LongInt;
implementation
uses Dos,Crt;
var
 regs:Registers;
procedure cursorlim(x1,y1,x2,y2:Integer);
begin
with regs do
begin
AX:=$07;
CX:=x1;
DX:=x2;
end;
intr($33,regs);
with regs do
begin
AX:=$08;
CX:=y1;
DX:=y2;
end;
intr($33,regs);

end;
procedure resetmouse;
begin
  regs.AX:=$00;
  Intr($33, regs);
end;
procedure showmouse;
begin
 regs.AX := $01;
 intr($33, regs);
end;
procedure hidemouse;
begin
 regs.AX := $02;
 intr($33, regs);
end;
procedure readmousestate(var x,y:Integer; var l,m,r:Boolean);
var
 button:Byte;
begin
 regs.AX:=$03;
 intr($33,regs);
 with regs do
 begin
  l:=False;
  m:=false;
  r:=false;
  button:=BL;
  x:=CX;
  y:=DX;
 end;
 if button = 1 then l:=true;
 if button = 2 then r:=true;
 if button = 0 then m:=true;
end;
procedure gotomouse(x,y:Integer);
begin
 with regs do
 begin
  AX := $04;
  BX := x;
  DX := y;
 end;
end;
procedure setcursorform(x,y:Integer; mask: Pointer);
begin
with regs do
 begin
  AX:=$09;
  BX:=Word(x);
  CX:=Word(y);
  ES:=Seg(mask^);
  DX:=Ofs(mask^);
 end;
intr($33,regs);
end;
function vs(x,tos:LongInt):LongInt;
var
 count,y:Longint;
begin
y:=1;
for count:=1 to tos do
begin
y:=y*x;
end;
vs:=y;
end;
function strtoint(s:String): longInt;
var
 v:longInt;
d:Integer;
begin
val(s,v,d);
strtoint:=v;
if d <> 0 then strtoint:=0;
end;
procedure getcursorformfile(s:String);
var
 masks:Array[0..1,0..15] of word;
 f:Text;
 resultr,x,y,count2,scount,count:Integer;
 s2:String;
begin
{$I-}
assign(f,s);
reset(f);
if IOResult <> 0 then exit;
{$I+}
readln(f,x,y);
count2:=1;
count:=0;
resultr:=0;
while not eof(f) do
begin
readln(f,s2);
for scount := 15 downto 0 do
begin
count2:=15-scount;
resultr:=resultr+strtoint(s2[scount+1])*vs(2,count2);
end;
masks[0,count]:=not resultr;
masks[1,count]:=resultr;
count:=count+1;
resultr:=0;
s2:='';
if count > 15 then break;
end;
close(f);
setcursorform(x,y,@masks);
{readln;}
end;
begin
end.