{$G+}
uses graph,crt,dos,mouse;
type
point3d = Record
 x,y,z:Integer;
 end;
const
 gr = pi /180;
 maxlines = 4000;
var
mapmemn,mapmemk:Array[0..maxlines] of point3d;
mapmemclr:Array[0..maxlines] of byte;
mapmemcnt:Integer;
int,m,gd,gm,maxx,maxy,oz,ox,oy,xm,ym,zm,tom,ozcs,diap,zoom:Integer;
t1,t2,vid,h1,h2,m1,m2,s1,s2,hu1,hu2:Word;
perspective,minimap,bool,mousel,mousem,mouser,videopage,nocontrol,control:Boolean;
centerosix,centerosiy:Integer;
mousex,mousey,e,tox,toy,diapmax:Integer;
key:Char;
mapname,whereman,musstr,wherebgi,fps:String;
p1,p2:Point3d;
tcos,tsin:array[0..359] of Extended;
function tan(x:Real) :Real;
begin
tan:=sin(x)/cos(x);
end;
function ctan(x:Real) :Real;
begin
ctan:=cos(x)/sin(x);
end;
function inttostr(x:longInt): String;
var
 d:String;
begin
str(x,d);
inttostr:=d;
end;
function strtoint(s:String): longInt;
var
 v:longInt;
d:Integer;
begin
val(s,v,d);
strtoint:=v;
if d <> 0 then strtoint:=0;
end;
procedure rotate(Ax,Ay,Az:Integer; var p: Point3d);
var
s1,s2,s3,c1,c2,c3:Extended;
Puit:Point3d;
begin
s1:=tsin[trunc(ax)];
c1:=tcos[trunc(ax)];
s2:=tsin[trunc(ay)];
c2:=tcos[trunc(ay)];
s3:=tsin[trunc(az)];
c3:=tcos[trunc(az)];
puit.x:=trunc(p.x*(c2*c3)+p.y*(c2*s3)-p.z*s2);
puit.y:=trunc(p.x*(s1*s2*c3-c1*s3)+p.y*(s1*s2*s3+c1*c3)+p.z*(s1*c2));
puit.z:=trunc(p.x*(c1*s2*c3+s1*s3)+p.y*(c1*s2*s3-s1*c3)+p.z*(c1*c2));
p:=puit;
end;
procedure transform(pt3d:Point3d; var x2d,y2d:Integer);
var
Thit:Real;
begin
if perspective then
begin
Thit:=1/(1-pt3d.x/e);
x2d:= trunc(centerosix+pt3d.y*thit);
y2d:= trunc(centerosiy-pt3d.z*thit);
end
else
begin
x2d:=trunc(centerosix+round(pt3d.y));
y2d:=trunc(centerosiy-round(pt3d.z));
end;
end;
procedure linec(x1,y1,x2,y2:Integer; color:byte);
begin
setcolor(color);line(x1,y1,x2,y2);
{setcolor(random(15)+1);
circle(x1,y1,random(5));circle(x2,y2,random(5));}
end;
procedure line3d(point1,point2:Point3d; color:byte);
var
x1,x2,y1,y2:Integer;
begin
transform(point1,x1,y1);
transform(point2,x2,y2);
if ((x1 > 0) and (x1 < maxx)) or ((y1 > 0) and (y1 < maxy)) then linec(x1,y1,x2,y2,color);
end;
procedure editstr(x1,y1,x2,y2,font,size,col,bgcol:Integer;var s:String);
var
 ch:Char;
 ss:String;
 x:Integer;
begin
ss:='';
s:='';
ch:=#0;
x:=0;
setfillstyle(1,bgcol);
setcolor(col);
settextstyle(font,0,size);
repeat
ch:=readkey;
if (ord(ch) >= 32) and (ord(ch) <= 126) then
begin
ss:=ss+ch;
end;
if ch = #8 then
begin
delete(ss,length(ss),1);
end;
setcolor(bgcol);
bar(x1,y1,x2,y2);
setcolor(col);
outtextxy(x1,y1,ss);
until ch=#13;
s:=ss;
end;
procedure draw_man(tmx,tmy,tmz,tx,ty,tz:Integer);
var
f:Text;
{x,y:Integer}
man1,man2:Point3d;
man_clr:Integer;
begin
assign(f,whereman+'\man.map');
reset(f);
while not eof(f) do
begin
readln(f,man1.x,man1.y,man1.z,man2.x,man2.y,man2.z,man_clr);
man1.x:=man1.x+tmx;
man1.y:=man1.y+tmy;
man1.z:=man1.z+tmz;
man2.x:=man2.x+tmx;
man2.y:=man2.y+tmy;
man2.z:=man2.z+tmz;
rotate(tx,ty,tz,man1);
rotate(tx,ty,tz,man2);
line3d(man1,man2,man_clr);
end;
close(f);
end;
procedure open_map;
var
pt1,pt2:Point3d;
clr:Byte;
cnt:Integer;
f:Text;
begin
{$I-}
assign(f,mapname);
reset(f);
if IOresult <> 0 then
begin
clrscr;
writeln('訡  饭  䠩: '+mapname);
write('  ...');
readkey;
halt;
end;
{$I+}
cnt:=0;
while not eof(f) do
begin
readln(f,pt1.x,pt1.y,pt1.z,pt2.x,pt2.y,pt2.z,clr);
mapmemn[cnt].x:=pt1.x;
mapmemn[cnt].y:=pt1.y;
mapmemn[cnt].z:=pt1.z;
mapmemk[cnt].x:=pt2.x;
mapmemk[cnt].y:=pt2.y;
mapmemk[cnt].z:=pt2.z;
mapmemclr[cnt]:=clr;
inc(cnt);
if cnt > maxlines then
begin
mapmemcnt:=cnt;
close(f);
end;
end;
mapmemcnt:=cnt;
close(f);
end;
procedure view_map;
var
n,m:Integer;
pt1,pt2:Point3d;
clr:Byte;
cnt:Integer;
begin
for cnt:=0 to mapmemcnt do
begin
pt1.x:=mapmemn[cnt].x;
pt1.y:=mapmemn[cnt].y;
pt1.z:=mapmemn[cnt].z;
pt2.x:=mapmemk[cnt].x;
pt2.y:=mapmemk[cnt].y;
pt2.z:=mapmemk[cnt].z;
clr:=mapmemclr[cnt];
pt1.x:=pt1.x+xm;
pt1.y:=pt1.y+ym;
pt1.z:=pt1.z-zm;
pt2.x:=pt2.x+xm;
pt2.y:=pt2.y+ym;
pt2.z:=pt2.z-zm;
if vid = 1 then
begin
pt1.x:=pt1.x*zoom;
pt1.y:=pt1.y*zoom;
pt1.z:=trunc(pt1.z*zoom-maxy/2);
pt2.x:=pt2.x*zoom;
pt2.y:=pt2.y*zoom;
pt2.z:=trunc(pt2.z*zoom-maxy/2);
end;
if vid = 2 then
begin
pt1.x:=pt1.x*zoom;
pt1.y:=pt1.y*zoom;
pt1.z:=pt1.z*zoom;
pt2.x:=pt2.x*zoom;
pt2.y:=pt2.y*zoom;
pt2.z:=pt2.z*zoom;
end;
rotate(ox,oy,oz,pt1);
rotate(ox,oy,oz,pt2);
if (pt2.x < diap) And (pt1.x < diap){ and (pt2.x > diap+diapmax) and (pt1.x > diap+diapmax) }then
begin
line3d(pt1,pt2,clr);
end;
end;
end;
procedure view3dorint;
var
p1,p2:Point3d;
x,y:Integer;
begin
setfillstyle(1,2);
bar(15,55,65,105);
centerosix:=40;
centerosiy:=80;
p2.x:=0;
p2.y:=0;
p2.z:=0;
p1.x:=20;
p1.y:=0;
p1.z:=0;
setcolor(14);
rotate(ox,oy,oz,p1);
transform(p1,x,y);
line(centerosix,centerosiy,x,y);
settextstyle(0,0,0);
outtextxy(x+2,y+2,'X');
p1.x:=0;
p1.y:=20;
p1.z:=0;
rotate(ox,oy,oz,p1);
transform(p1,x,y);
line(centerosix,centerosiy,x,y);
settextstyle(0,0,0);
outtextxy(x+2,y+2,'Y');
p1.x:=0;
p1.y:=0;
p1.z:=20;
rotate(ox,oy,oz,p1);
transform(p1,x,y);
line(centerosix,centerosiy,x,y);
settextstyle(0,0,0);
outtextxy(x+2,y+2,'Z');
centerosix:=maxx div 2;
centerosiy:=maxy div 2;
end;
begin
for int := 0 to 359 do
begin
tsin[int]:=sin(int*gr);
tcos[int]:=cos(int*gr);
end;
{--------------------------------------}
mapname:='maps\map100h.map';
open_map;
{--------------------------------------}
gd:=9;gm:=1;
wherebgi:='';
whereman:='maps';
nocontrol:=true;
randomize;
initgraph(gd,gm,wherebgi);
control:=false;
maxx:=640;
maxy:=350;
centerosix:=maxx div 2;
centerosiy:=maxy;
vid:=1;
videopage:=true;
perspective:=true;
ox:=0;
oy:=0;
oz:=50;
hu2:=0;
hu1:=0;
xm:=0000;
ym:=0000;
zm:=0000;
zoom:=10;
diap:=0;
e:=500;
diapmax:=8000;
tom:=0;
setbkcolor(0);
if diap > e then diap :=e;
resetmouse;
hidemouse;
repeat
gettime(h1,m1,s1,hu1);
if videopage then
begin
m:=1-m;
setactivepage(m);
end;
if ox < 0 then ox:=359;
if oz < 0 then oz:=359;
if oy < 0 then oy:=359;
if oy > 359 then oy:=0;
if ox > 359 then ox:=0;
if oz > 359 then oz:=0;
if control or nocontrol then
begin
cleardevice;
view_map;
view3dorint;
control:=false;
if vid = 1 then
begin
zoom := 5;
setcolor(9);
setcolor(15);
{circle(maxx div 2,maxy div 2,10);
putpixel(maxx div 2,maxy div 2,15);}
end;
if vid = 2 then
begin
zoom := 1;
draw_man(0,0,0,ox,oy,0);
end;
end;
readmousestate(mousex,mousey,mousel,mousem,mouser);
if (mousex <> maxx div 2) or (mousey <> maxy div 2) then
begin
if mousel then ox:=ox-(maxx div 2 - mousex)
else oz:=oz+(maxx div 2 - mousex);
oy:=oy+(maxy div 2 - mousey);
mousel:=false;
resetmouse;
control:=true;
end;
key:=#1;
if keypressed then key:=readkey;
if key <> #1 then control:=true;
if key = #9 then
begin
if zoom = 1 then
begin
vid := 1;
diap:= 0;
end;
if zoom = 5 then
begin
vid := 2;
diap:= e-100;
end;
end;
if key = #0 then
 begin
  key:=readkey;
  while keypressed do  key:=readkey;
  case key of
  #72:
  begin
  tom:=20;
  xm:=trunc(xm+tom*cos(oy*gr)*cos(oz*gr));
  ym:=trunc(ym+tom*cos(oy*gr)*sin(oz*gr));
  zm:=trunc(zm+tom*sin(oy*gr));
  tom:=0;
  end;
  #80:
  begin
  tom:=-20;
  xm:=trunc(xm+tom*cos(oy*gr)*cos(oz*gr));
  ym:=trunc(ym+tom*cos(oy*gr)*sin(oz*gr));
  zm:=trunc(zm+tom*sin(oy*gr));
  tom:=0;
  end;
  #75:oz:=oz+10;
  #77:oz:=oz-10;
  #71:begin
  ox:=0;
  end;
end;
end;
if key = #27 then
begin
key:=#1;
closegraph;
halt;
end;
if zoom < 1 then zoom := 1;
setcolor(15);
gettime(h2,m2,s2,hu2);
t1:=s1*100+hu1;
t2:=s2*100+hu2;
if t2-t1 <> 0 then fps:=inttostr(trunc(100/(t2-t1)))
else fps:='MAX';
outtextxy(10,10,'X:'+inttostr(xm)+' Y:'+inttostr(ym)+' Z:'+inttostr(zm)+' Ox:'+inttostr(ox)+
' Oy:'+inttostr(oy)+' Oz:'+inttostr(oz)+' FPS:'+fps);
if videopage then setvisualpage(m);
key:=#1;
until false;
closegraph;
end.